/*
 * @(#)IIIMWindow.java	1.3 99/04/06
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.awt.im.iiimp;

import java.awt.*;
import com.sun.iiim.*;
 
// Abstract class for GUI Window
public abstract class IIIMWindow extends IIIMComponent {
    public Window window;
    static int screenHeight;
    static int screenWidth;

    static {
	Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
	screenHeight = d.height;
	screenWidth = d.width;
    }
         
    synchronized void hide() {
        if(window != null)
            window.setVisible(false);
    }
     
    synchronized void show() {
        if(window != null)
            window.setVisible(true);
    }
     
}
