/*
 * @(#)IIIMPreeditListener.java	1.6 99/09/01
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package com.sun.iiim;

/**
 * Preedit GUI object class must implements this interface.
 */
public interface IIIMPreeditListener extends IIIMListener {
    /**
     * When preedit starts, this method is invoked.
     *
     * @param e	<code>IIIMPreeditEvent</code>
     */
    void preeditStart(IIIMPreeditEvent e);

    /**
     * When preedit string is produced, this method is invoked.
     *
     * @param e	<code>IIIMPreeditEvent</code>
     */
    void preeditDraw(IIIMPreeditEvent e);

    /**
     * When preedit done, this method is invoked.
     *
     * @param e	<code>IIIMPreeditEvent</code>
     */
    void preeditDone(IIIMPreeditEvent e);
}
