/*
 * @(#)IIIMStatusListener.java	1.6 99/09/01
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package com.sun.iiim;

/**
 * Status GUI object class must implements this interface.
 */
public interface IIIMStatusListener extends IIIMListener {
    /**
     * When status starts, this method is invoked.
     *
     * @param e <code>IIIMStatusEvent</code>
     */
    void statusStart(IIIMStatusEvent e);

    /**
     * When status string is produced, this method is invoked.
     *
     * @param e <code>IIIMStatusEvent</code>
     */
    void statusDone(IIIMStatusEvent e);

    /**
     * When status done, this method is invoked.
     *
     * @param e <code>IIIMStatusEvent</code>
     */
    void statusDraw(IIIMStatusEvent e);
}
