/*
 * Copyright 1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;
import javax.swing.tree.*;
import javax.swing.undo.*;
import java.awt.*;
import java.awt.event.*;

public class PropertyPanel extends JPanel {
    GridBagLayout gb;
    GridBagConstraints c;
    public PropertyPanel() {
        gb=new GridBagLayout();
        c=new GridBagConstraints();
        c.insets = new Insets(2, 4, 2, 4);
        setLayout(gb);
    }
    public void addHeader(Component j) {
        if (j instanceof JLabel) {
            //((JLabel)j).setAlignment(JLabel.RIGHT);
        }
        c.fill = GridBagConstraints.BOTH;
        c.weightx = 0.0;
        c.gridwidth=1;
        gb.setConstraints(j,c);
        add(j);
    }
    public void addFilledMiddle(Component j) {
        c.weightx = 1.0;
        c.fill = GridBagConstraints.HORIZONTAL;
        gb.setConstraints(j,c);
        add(j);
    }
    public void addMiddle(Component j) {
        c.weightx = 1.0;
        c.gridwidth=1;
        c.fill = GridBagConstraints.HORIZONTAL;
        gb.setConstraints(j,c);
        add(j);
    }
    public void addAnchor(Component j) {
        addAnchor(j, 1.0);
    }
    public void addRealAnchor(Component j) {
        addAnchor(j, 0.0);
    }
    public void addFixedAnchor(Component j) {
        c.weightx = 0.0;
        c.gridwidth=GridBagConstraints.REMAINDER;
        c.fill = GridBagConstraints.NONE;
        gb.setConstraints(j,c);
        add(j);
    }
    public void addAnchor(Component j, double weightx) {
        c.weightx = weightx;
        c.gridwidth=GridBagConstraints.REMAINDER;
        c.fill = GridBagConstraints.HORIZONTAL;
        gb.setConstraints(j,c);
        add(j);
    }
}
